uses graph,crt;
const
  n=8;
type
  CubCoord=array[1..n,1..3] of real;
  Matr    =array[1..4,1..4] of real;
const
  d=10000;
  f=70;
  _v1=5;_v2=3;_v3=2;
  ca=2;cb=1;cc=1;
  alpha=-0.005;
  _cub   :CubCoord=
          ((0,0,0),(1,0,0),(1,0,1),(0,0,1),(0,1,1),(1,1,1),(1,1,0),(0,1,0));
var
 driver,mode,i,j  :integer;
 cub              :CubCoord;
 x,y,z            :real;
 R                :Matr;
procedure MMult(var a,b,res :Matr);
var
   i,j     :integer;
begin
   for i:=1 to 4 do
     for j:=1 to 4 do
        res[i,j]:=a[i,1]*b[1,j]+a[i,2]*b[2,j]+a[i,3]*b[3,j]+a[i,4]*b[4,j];
end;
procedure CalculateMatr;
var
  A,B       :Matr;
  th,fi,p   :real;
  v1,v2,v3  :real;
begin
  v1:=_v1;v2:=_v2;v3:=_v3;
  p:=sqrt(sqr(v1)+sqr(v2)+sqr(v3));
  if v3=0 then fi:=pi/2 else fi:=ArcTan (sqrt (1-sqr (v3/p)) /(v3/p));
  if (v1=0) and (v2>=0) then th:=pi/2 else
  if (v1=0) and (v2<0) then th:=3*pi/2 else
  if v1>0 then th:=arctan(v2/v1) else
  if v1<0 then th:=pi+arctan(v2/v1);
  A[1,1]:=cos(th) ;A[1,2]:=-sin(th);A[1,3]:=0;A[1,4]:=0;
  A[2,1]:=sin(th) ;A[2,2]:=cos(th) ;A[2,3]:=0;A[2,4]:=0;
  A[3,1]:=0       ;A[3,2]:=0       ;A[3,3]:=1;A[3,4]:=0;
  A[4,1]:=0       ;A[4,2]:=0       ;A[4,3]:=0;A[4,4]:=1;
  B[1,1]:=cos(fi) ;B[1,2]:=0       ;B[1,3]:=sin(fi);B[1,4]:=0;
  B[2,1]:=0       ;B[2,2]:=1       ;B[2,3]:=0;      B[2,4]:=0;
  B[3,1]:=-sin(fi);B[3,2]:=0       ;B[3,3]:=cos(fi);B[3,4]:=0;
  B[4,1]:=0       ;B[4,2]:=0       ;B[4,3]:=0;      B[4,4]:=1;
  MMult(A,B,R);
  A:=R;
  B[1,1]:=cos(alpha);B[1,2]:=sin(alpha);B[1,3]:=0;  B[1,4]:=0;
  B[2,1]:=-sin(alpha);B[2,2]:=cos(alpha);B[2,3]:=0; B[2,4]:=0;
  B[3,1]:=0;B[3,2]:=0;B[3,3]:=1;                    B[3,4]:=0;
  B[4,1]:=0;B[4,2]:=0;B[4,3]:=0;                    B[4,4]:=1;
  MMult(A,B,R);
  A:=R;
  B[1,1]:=cos(fi) ;B[1,2]:=0       ;B[1,3]:=-sin(fi);B[1,4]:=0;
  B[2,1]:=0       ;B[2,2]:=1       ;B[2,3]:=0;       B[2,4]:=0;
  B[3,1]:=sin(fi) ;B[3,2]:=0       ;B[3,3]:=cos(fi); B[3,4]:=0;
  B[4,1]:=0       ;B[4,2]:=0       ;B[4,3]:=0;       B[4,4]:=1;
  MMult(A,B,R);
  A:=R;
  B[1,1]:=cos(th) ;B[1,2]:=sin(th) ;B[1,3]:=0; B[1,4]:=0;
  B[2,1]:=-sin(th);B[2,2]:=cos(th) ;B[2,3]:=0; B[2,4]:=0;
  B[3,1]:=0       ;B[3,2]:=0       ;B[3,3]:=1; B[3,4]:=0;
  B[4,1]:=0       ;B[4,2]:=0       ;B[4,3]:=0; B[4,4]:=1;
  MMult(A,B,R);
  B:=R;
  A[1,1]:=1       ;A[1,2]:=0       ;A[1,3]:=0; A[1,4]:=0;
  A[2,1]:=0       ;A[2,2]:=1       ;A[2,3]:=0; A[2,4]:=0;
  A[3,1]:=0       ;A[3,2]:=0       ;A[3,3]:=1; A[3,4]:=0;
  A[4,1]:=-ca     ;A[4,2]:=-cb     ;A[4,3]:=-cc; A[4,4]:=1;
  MMult(A,B,R);
  B[1,1]:=1       ;B[1,2]:=0       ;B[1,3]:=0; B[1,4]:=0;
  B[2,1]:=0       ;B[2,2]:=1       ;B[2,3]:=0; B[2,4]:=0;
  B[3,1]:=0       ;B[3,2]:=0       ;B[3,3]:=1; B[3,4]:=0;
  B[4,1]:=ca      ;B[4,2]:=cb      ;B[4,3]:=cc; B[4,4]:=1;
  A:=R;
  MMult(A,B,R);
end;
procedure DrawCube(var pCub :CubCoord;color :Integer);
var
sC  :array[1..n,1..2] of integer;
i   :integer;
begin
setlinestyle(0,6,3);
    for i:=1 to n do begin
       sC[i,1]:=round(pcub[i,1]/(pcub[i,3]+f)*d+GetMaxX/2);
       sC[i,2]:=round(pcub[i,2]/(pcub[i,3]+f)*d+GetMaxY/2);
    end;
    setcolor(color);
    line(sC[1,1],sc[1,2],sc[2,1],sc[2,2]);
    line(sC[1,1],sc[1,2],sc[4,1],sc[4,2]);
    line(sC[1,1],sc[1,2],sc[8,1],sc[8,2]);
    line(sC[5,1],sc[5,2],sc[6,1],sc[6,2]);
    line(sC[3,1],sc[3,2],sc[6,1],sc[6,2]);
    line(sC[6,1],sc[6,2],sc[7,1],sc[7,2]);
    line(sC[7,1],sc[7,2],sc[8,1],sc[8,2]);
    line(sC[2,1],sc[2,2],sc[7,1],sc[7,2]);
    line(sC[4,1],sc[4,2],sc[5,1],sc[5,2]);
    line(sC[5,1],sc[5,2],sc[8,1],sc[8,2]);
    line(sC[2,1],sc[2,2],sc[3,1],sc[3,2]);
    line(sC[3,1],sc[3,2],sc[4,1],sc[4,2]);
  end;
begin
   InitGraph(driver,mode,'c:\bp\bgi');
   if GraphResult<>0 then exit;
   CalculateMatr;
   for i:=1 to n do
     for j:=1 to 3 do cub[i,j]:=_cub[i,j];
   repeat
      DrawCube(cub,0);
      for i:=1 to n do begin
        x:=cub[i,1];y:=cub[i,2];z:=cub[i,3];
        for j:=1 to 3 do
         cub[i,j]:=x*R[1,j]+y*R[2,j]+z*R[3,j]+R[4,j];
      end;
      DrawCube(cub,15);
      Delay(50);
   until keypressed;ReadKey;
end.
